package com.ruixuan.launch.entity;


import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruixuan.common.annotation.Excel;
import lombok.Data;

import java.util.Date;

/**
 * 广告计划信息对象 kuaishou_launch_campaign
 *
 * @author ruoyi
 * @date 2022-06-23
 */
@Data
public class KuaishouLaunchCampaign {
    private static final long serialVersionUID = 1L;

    /**
     *
     */
    private String id;

    /**
     * 账户ID
     */
    @Excel(name = "账户ID")
    private Long accountId;

    /**
     * 计划ID
     */
    @Excel(name = "计划ID")
    private Long campaignId;

    /**
     * 计划名称
     */
    @Excel(name = "计划名称")
    private String campaignName;

    /**
     * 日期
     */
    @Excel(name = "日期")
    private String statDate;

    /**
     * 计划类型	3：获取电商下单 13：小店商品推广 14：直播推广
     */
    @Excel(name = "计划类型	3：获取电商下单 13：小店商品推广 14：直播推广")
    private Integer campaignType;

    /**
     * 推广方式1：极速推广,2：专业推广（当前支持）
     */
    @Excel(name = "推广方式1：极速推广,2：专业推广", readConverterExp = "当=前支持")
    private Integer promotionType;

    /**
     * 投放状态 1-投放、2-暂停
     */
    @Excel(name = "投放状态 1-投放、2-暂停")
    private Integer putStatus;

    /**
     * 单日预算金额 单位：厘，0表示预算不限，默认0
     */
    @Excel(name = "单日预算金额 单位：厘，0表示预算不限，默认0")
    private Long dayBudget;

    /**
     * 分日预算
     */
    @Excel(name = "分日预算")
    private String budgetSchedule;

    /**
     * 更新时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;

    /**
     * 创建时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;

}