package com.ruixuan.launch.entity;


import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruixuan.common.annotation.Excel;
import lombok.Data;

import java.util.Date;

/**
 * 广告组定向信息对象 kuaishou_launch_group_target
 *
 * @author ruoyi
 * @date 2022-06-28
 */
@Data
public class KuaishouLaunchGroupTarget {
    private static final long serialVersionUID = 1L;

    private Long id;

    /**
     * 账户ID
     */
    @Excel(name = "账户ID")
    private Long accountId;

    /**
     * 广告组ID
     */
    @Excel(name = "广告组ID")
    private Long unitId;

    /**
     * 地域
     */
    @Excel(name = "地域")
    private String region;

    /**
     * 地域类型 0：不限 1：指定地区 3：城市等级
     */

    private String regionType;
    /**
     * 自定义年龄段
     */
    @Excel(name = "自定义年龄段")
    private String age;

    /**
     * 性别 1：女性, 2：男性， 0：不限
     */
    @Excel(name = "性别 1：女性, 2：男性， 0：不限")
    private Long genderType;

    /**
     * 人群包定向
     */
    @Excel(name = "人群包定向")
    private String population;

    /**
     * 人群包排除
     */
    @Excel(name = "人群包排除")
    private String excludePopulation;

    /**
     * 付费人群包 id
     */
    @Excel(name = "付费人群包 id")
    private String paidAudience;

    /**
     * 行为类型 0:关注 1:视频互动 2:直播互动
     */
    @Excel(name = "行为类型 0:关注 1:视频互动 2:直播互动")
    private String behaviorList;

    /**
     * 快手网红信息
     */
    @Excel(name = "快手网红信息")
    private String fansStarList;

    /**
     * 快手网红信息
     */
    @Excel(name = "快手网红信息")
    private String purchaseIntention;

    /**
     * 更新时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;

    /**
     * 创建时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;
}