package com.ruixuan.bytedance.mapper;

import com.alibaba.fastjson.JSONObject;
import com.ruixuan.bytedance.entity.BytedancePromoterOrderList;
import org.apache.ibatis.annotations.Param;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * 团长订单Mapper接口
 *
 * @author ruoyi
 * @date 2023-08-28
 */
public interface BytedancePromoterOrderListMapper
{
    /**
     * 查询团长订单
     *
     * @param orderId 团长订单主键
     * @return 团长订单
     */
    public BytedancePromoterOrderList selectBytedancePromoterOrderListByOrderId(Long orderId);

    /**
     * 查询团长订单列表
     *
     * @param bytedancePromoterOrderList 团长订单
     * @return 团长订单集合
     */
    public List<BytedancePromoterOrderList> selectBytedancePromoterOrderListList(BytedancePromoterOrderList bytedancePromoterOrderList);

    List<JSONObject> getBytedanceOrderList(Map<String, Object> requestMap);

    List<JSONObject> getTopOrders(Map<String, Object> requestMap);

    List<JSONObject> bytedanceBDReportList(Map<String, Object> requestMap);

    List<JSONObject> anchorBytedanceOrderDetail(Map<String, Object> requestMap);

    List<JSONObject> bytedanceItemList(Map<String, Object> requestMap);

    List<JSONObject> adminBytedanceReportList(Map<String, Object> requestMap);

    List<JSONObject> adminBytedanceReportListByBind(Map<String, Object> requestMap);

    List<JSONObject> getBytedanceTopPromoterByItemId(Map<String, Object> requestMap);

    List<JSONObject> bytedanceOrderStatistics(Map<String, Object> requestMap);

    List<JSONObject> bytedanceItemDetail(Map<String, Object> requestMap);

    List<JSONObject> bytedanceBDTotal(Map<String, Object> requestMap);

    List<JSONObject> bytedanceBDDetailList(Map<String, Object> requestMap);

    JSONObject bytedanceUserItemTotal(Map<String, Object> requestMap);

    List<JSONObject> bytedanceUserItemDetail(Map<String, Object> requestMap);

    List<JSONObject> exportBytedancePromoter(Map<String, Object> requestMap);

    List<JSONObject> bdReportList(Map<String, Object> requestMap);

    List<JSONObject> bdReportListByBind(Map<String, Object> requestMap);

    List<JSONObject> getproDate();

    BigDecimal getCount(@Param("promoterId") String promoterId, @Param("start") Long start, @Param("end") Long end);
}
