package com.ruixuan.data.mapper;

import com.ruixuan.data.entity.KuaishouLiveDataKanban;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 直播数据看板Mapper接口
 *
 * @author ruoyi
 * @date 2022-05-31
 */
public interface KuaishouLiveDataKanbanMapper {
    /**
     * 查询直播数据看板
     *
     * @param ksId 直播数据看板主键
     * @return 直播数据看板
     */
    public KuaishouLiveDataKanban selectKuaishouLiveDataKanbanByKsId(Long ksId);

    /**
     * 查询直播数据看板列表
     *
     * @param kuaishouLiveDataKanban 直播数据看板
     * @return 直播数据看板集合
     */
    public List<KuaishouLiveDataKanban> selectKuaishouLiveDataKanbanList(KuaishouLiveDataKanban kuaishouLiveDataKanban);

    /**
     * 新增直播数据看板
     *
     * @param kuaishouLiveDataKanban 直播数据看板
     * @return 结果
     */
    public int insertKuaishouLiveDataKanban(KuaishouLiveDataKanban kuaishouLiveDataKanban);

    /**
     * 修改直播数据看板
     *
     * @param kuaishouLiveDataKanban 直播数据看板
     * @return 结果
     */
    public int updateKuaishouLiveDataKanban(KuaishouLiveDataKanban kuaishouLiveDataKanban);

    /**
     * 删除直播数据看板
     *
     * @param ksId 直播数据看板主键
     * @return 结果
     */
    public int deleteKuaishouLiveDataKanbanByKsId(Long ksId);

    /**
     * 批量删除直播数据看板
     *
     * @param ksIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteKuaishouLiveDataKanbanByKsIds(Long[] ksIds);

    int inserExcelBatchInfo(@Param(value = "kanbanList") List<KuaishouLiveDataKanban> kanbanList);
}
