package com.ruixuan.data.service;

import com.alibaba.fastjson.JSONObject;
import com.ruixuan.data.entity.KuaishouLiveDataKanban;
import com.ruixuan.live.entity.KuaishouLiveBroadcast;

import java.util.List;

/**
 * 直播数据看板Service接口
 *
 * @author ruoyi
 * @date 2022-05-31
 */
public interface IKuaishouLiveDataKanbanService {
    /**
     * 查询直播数据看板
     *
     * @param ksId 直播数据看板主键
     * @return 直播数据看板
     */
    public KuaishouLiveDataKanban selectKuaishouLiveDataKanbanByKsId(Long ksId);

    /**
     * 查询直播数据看板列表
     *
     * @param kuaishouLiveDataKanban 直播数据看板
     * @return 直播数据看板集合
     */
    public List<KuaishouLiveDataKanban> selectKuaishouLiveDataKanbanList(KuaishouLiveDataKanban kuaishouLiveDataKanban);

    /**
     * 新增直播数据看板
     *
     * @param kuaishouLiveDataKanban 直播数据看板
     * @return 结果
     */
    public int insertKuaishouLiveDataKanban(KuaishouLiveDataKanban kuaishouLiveDataKanban);

    /**
     * 修改直播数据看板
     *
     * @param kuaishouLiveDataKanban 直播数据看板
     * @return 结果
     */
    public int updateKuaishouLiveDataKanban(KuaishouLiveDataKanban kuaishouLiveDataKanban);

    /**
     * 批量删除直播数据看板
     *
     * @param ksIds 需要删除的直播数据看板主键集合
     * @return 结果
     */
    public int deleteKuaishouLiveDataKanbanByKsIds(Long[] ksIds);

    /**
     * 删除直播数据看板信息
     *
     * @param ksId 直播数据看板主键
     * @return 结果
     */
    public int deleteKuaishouLiveDataKanbanByKsId(Long ksId);

    int inserExcelInfo(KuaishouLiveBroadcast broadcast,List<JSONObject> list) throws Exception;
}
