package com.ruixuan.isc.controller;

import com.alibaba.fastjson.JSONObject;
import com.ruixuan.isc.service.IKwaiJSTService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

@RestController
@Api(tags = "聚水潭")
@RequestMapping("/kwaixiaodian/jst")
public class KwaiJSTController {
    @Autowired
    private IKwaiJSTService kwaiJSTService;

    static ExecutorService dateService = Executors.newFixedThreadPool(6);

    @GetMapping(value = "/refreshToken")
    @ApiOperation(value = "refreshToken")
    public JSONObject refreshToken() {
        return kwaiJSTService.refreshToken();
    }

    /**
     * https://openweb.jushuitan.com/dev-doc?docType=2&docId=14
     * 普通商品资料查询（按sku查询） + 组合装商品查询
     * 对应数据表：ruixuan.kwaixiaodian_jst
     */
    @GetMapping(value = "/queryAndInsertSku")
    @ApiOperation(value = "普通商品资料查询（按sku查询）+组合装商品查询")
    public void queryAndInsertSku(@ApiParam("时间") @RequestParam(value = "date", required = false) String date) {
//        List<String> allDatesOfTwoTimes = DateUtils.getAllDatesOfTwoTimes("2024-01-01", "2024-11-25");
//        allDatesOfTwoTimes.forEach(dates -> dateService.submit(() -> {
        try {
//            Thread.sleep(5000L);
            kwaiJSTService.queryAndInsertSku(date);
        } catch (Exception e) {
            e.printStackTrace();
        }
//        }));
    }

    /**
     * https://openweb.jushuitan.com/dev-doc?docType=6&docId=26
     * 采购单查询
     * 对应数据表：ruixuan.kwaixiaodian_jst_purchase、kwaixiaodian_jst_purchase_item
     */
    @GetMapping(value = "/queryAndInsertPurchase")
    @ApiOperation(value = "采购单查询")
    public void queryAndInsertPurchase(@ApiParam("时间") @RequestParam(value = "date", required = false) String date) {
        try {
            kwaiJSTService.queryAndInsertPurchase(date);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


}
