package com.ruixuan.isc.entity;

import lombok.Data;
import org.springframework.data.annotation.Transient;

/**
 * kwaixiaodian商品详情对象 kwaixiaodian_item_get
 *
 * @date 2024-10-28
 */
@Data
public class KwaixiaodianItemGet {
    private static final long serialVersionUID = 1L;

    /**
     * 商品ID
     */
    private Long id;
    private Long itemId;
    private Integer itemType;

    /**
     * 用户ID
     */
    private Long userId;
    private Long courtshipPurchaseId;

    /**
     * 用户名称
     */
    private String userName;
    private String courtshipPurchaseName;


    /**
     * 店铺id
     */
    private String shopId;

    /**
     * 店铺名称
     */
    private String shopName;

    /**
     * 公司ID
     */
    private Long
            companyId;

    /**
     * 公司名称
     */
    private String companyName;

    /**
     * 负责人
     */
    private String leaderName;

    /**
     * 三方商品id
     */
    private Long relItemId;

    /**
     * 商品所属类目id
     */
    private Long categoryId;

    /**
     * 商品所属类目名称
     */
    private String categoryName;

    /**
     * 父级类目id
     */
    private Long parentCategoryId;

    /**
     * 父级类目名称
     */
    private String parentCategoryName;

    /**
     * 根类目id
     */
    private Long rootCategoryId;

    /**
     * 根类目名称
     */
    private String rootCategoryName;

    /**
     * 商品标题
     */
    private String title;

    /**
     * 商品详情
     */
    private String details;

    /**
     * 商品图片URL（第一张默认为头图)
     */
    private String imageUrls;
    /**
     * 商品图片URL
     */
    private String imageUrl;

    /**
     * 图文详情图片
     */
    private String detailImageUrls;

    /**
     * 服务规则
     */
    private String serviceRule;

    /**
     * 审核状态 0待审核 1审核待修改 2审核通过 3审核拒绝
     */
    private String auditStatus;

    /**
     * 审核原因
     */
    private String auditReason;

    /**
     * 创建时间 （毫秒）
     */
    private Long createdTimeMs;

    /**
     * 创建时间 （日：时分秒）
     */
    private String createdTime;

    /**
     * 更新时间 （毫秒）
     */
    private Long updateTimeMs;

    /**
     * 更新时间 （日：时分秒）
     */
    private String updateTime;

    /**
     * 上下架状态
     */
    private String onOfflineStatus;

    /**
     * 父级类目列表
     */
    private String parentCategoryList;

    /**
     * 商品属性列表
     */
    private String itemPropValues;

    /**
     * 运费模板ID
     */
    private Long expressTemplateId;

    /**
     * 是否限购，1:支持限购，0:不支持限购
     */
    private String purchaseLimit;

    /**
     * 限购数量
     */
    private Long limitCount;

    /**
     * 商品链接
     */
    private String linkUrl;

    /**
     * 商品开售时间，单位：分
     */
    private Long timeOfSale;

    /**
     * 商品备注
     */
    private String itemRemark;

    /**
     * 副本审核状态 0待审核 1审核待修改 2审核通过 3审核拒绝
     */
    private String duplicationStatus;

    /**
     * 副本审核原因
     */
    private String duplicationReason;

    /**
     * 1-货品库存模式；2-商品库存模式
     */
    private String multipleStock;

    /**
     * 门店ID
     */
    private String poiIds;

    /**
     * 商品白底图
     */
    private String whiteBaseImageUrl;

    /**
     * 商品透明图
     */
    private String transparentImageUrl;

    /**
     * 商品短标题
     */
    private String shortTitle;

    /**
     * 商品卖点
     */
    private String sellingPoint;

    /**
     * 使用说明
     */
    private String instructions;

    /**
     * 是否是合约机商品
     */
    private String contractPhone;

    /**
     * 下架原因
     */
    private String offlineReason;

    /**
     * 下架原因
     */
    private String itemQualification;
    private String dataCreateTime;

    /**
     * 标品ID
     */
    private Long spuId;
    /**
     * 商品价格 单位:分
     */
    private Long price;
    @Transient
    private String skuPrice;


}
