package com.ruixuan.isc.entity;

import lombok.Data;

import java.math.BigDecimal;

/**
 * 商品信息-聚水潭对象 kwaixiaodian_jst
 */
@Data
public class KwaixiaodianJst {

    /**
     * 商品编码
     */
    private String skuId;

    /**
     * 1-普通商品，2-组合商品
     */
    private String dataType;

    /**
     * 款式编码
     */
    private String iId;

    /**
     * 商品名称
     */
    private String name;

    /**
     * 商品简称
     */
    private String shortName;

    /**
     * 备注
     */
    private String remark;

    /**
     * 销售价
     */
    private BigDecimal salePrice;

    /**
     * 成本价
     */
    private BigDecimal costPrice;

    /**
     * 颜色规格
     */
    private String propertiesValue;

    /**
     * 颜色
     */
    private String color;

    /**
     * 类目id
     */
    private Long cId;

    /**
     * 分类
     */
    private Long category;

    /**
     * 大图地址
     */
    private String picBig;

    /**
     * 图片地址
     */
    private String pic;

    /**
     * 是否启用，0：备用，1：启用，-1：禁用
     */
    private Long enabled;

    /**
     * 重量
     */
    private BigDecimal weight;

    /**
     * 市场价
     */
    private BigDecimal marketPrice;

    /**
     * 品牌
     */
    private String brand;

    /**
     * 供应商编号；对应页面：供应商信息-供应商内部编码
     */
    private String supplierId;

    /**
     * 供应商名称
     */
    private String supplierName;

    /**
     * 国标码
     */
    private String skuCode;

    /**
     * 供应商商品编码
     */
    private String supplierSkuId;

    /**
     * 供应商商品款号
     */
    private String supplierIId;

    /**
     * 虚拟分类
     */
    private String vcName;

    /**
     * 商品类型
     */
    private String skuType;

    /**
     * 创建者
     */
    private String creator;

    /**
     * 创建时间
     */
    private String created;

    /**
     * 修改时间
     */
    private String modified;

    /**
     * 商品属性，成品，半成品，原材料，包材
     */
    private String itemType;

    /**
     * 是否禁止同步，0=启用同步，1=禁用同步，2=部分禁用
     */
    private Long stockDisabled;

    /**
     * 单位
     */
    private String unit;

    /**
     * 保质期
     */
    private Long shelfLife;

    /**
     * 商品标签，多个标签时以逗号分隔
     */
    private String labels;

    /**
     * 生产许可证
     */
    private String productionLicence;

    /**
     * 长
     */
    private Long l;

    /**
     * 宽
     */
    private Long w;

    /**
     * 高
     */
    private Long h;

    /**
     * 是否开启序列号
     */
    private String isSeriesNumber;
}
