package com.ruixuan.isc.mapper;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.ruixuan.isc.entity.JYOrderItemList;
import com.ruixuan.isc.entity.KuaishouItemCategory;
import com.ruixuan.isc.entity.KuaishouItemList;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 【请填写功能名称】Mapper接口
 *
 * @author ruoyi
 * @date 2023-02-03
 */
public interface KuaishouItemListMapper {

    List<KuaishouItemList> getItemList(Map<String, Object> requestMap);

    KuaishouItemList getItemInfoByItemId(Long itemId);

    void insertItem(@Param("kuaishouItemList") KuaishouItemList kuaishouItemList, @Param("ownershipId") String ownershipId);

    int updateKuaishouItemList(KuaishouItemList kuaishouItemList);

    int deleteKuaishouItemListByItemIds(Long[] itemIds);

    void batchCategory(@Param("adds") List<KuaishouItemCategory> adds);

    KuaishouItemCategory getCategoryInfo(@Param("categoryId") Long categoryId);

    void insertItemBindUser(@Param("itemId") Long itemId, @Param("userId") Long userId, @Param("userName") String userName, @Param("targetOwnershipId") String targetOwnershipId);

    Long getIdByName(@Param("categoryName") String categoryName);

    List<JSONObject> getCategoryIds();

    void updateCount(@Param("itemId") Long itemId, @Param("sampleCount") Integer sampleCount, @Param("userCount") Integer userCount);

    List<Long> getActivityIds(@Param("userId") Long userId);

    List<JSONObject> selectItemInfo(@Param("map") Map<Long, Long> map);

    Integer getSampleCount(@Param("itemId") Long itemId);

    void removeById(@Param("itemId") Long itemId);

    void batchItemProcess(@Param("itemIds") JSONArray itemIds, @Param("status") Integer status, @Param("examineId") Long examineId, @Param("examineName") String examineName);

    List<JSONObject> getRegimental();

    Long selectMaxRelateId(@Param("targetOwnershipId") String targetOwnershipId);

    List<JSONObject> getListByRelateId(@Param("relateId") Long relateId);

    String getItemImgUrl(Long itemId);

    List<JSONObject> itemList();

    JSONObject selectRuleItemByItemId(@Param("itemId") Long itemId);

    List<JYOrderItemList> getJYOrderItemList(@Param("itemTitle") String itemTitle, @Param("startDate") String startDate, @Param("endDate") String endDate);

    List<JSONObject> getDataOwnership();

    Long checkUser(@Param("ownershipId") String ownershipId, @Param("userName") String userName);

    String selectDataOwnershipNameById(@Param("ownershipId") String ownershipId);

    JSONObject getUserInfo(@Param("userName") String userName, @Param("targetOwnershipId") String targetOwnershipId);

    void insertRuiXuanItem(KuaishouItemList kuaishouItemList);

    void insertMiaoGouSiItem(KuaishouItemList kuaishouItemList);

    void insertRocketItem(KuaishouItemList kuaishouItemList);

    void insertYufuItem(KuaishouItemList kuaishouItemList);

    void insertYuxiuItem(KuaishouItemList kuaishouItemList);

    void insertZhishuiItem(KuaishouItemList kuaishouItemList);


    void insertItemCheck(@Param("itemId") Long itemId, @Param("targetOwnershipId") String targetOwnershipId);

    String getItemOwnership(@Param("itemId") Long itemId);

    List<JSONObject> getCleanData();

    Integer checkItemData(@Param("ownershipId") String ownershipId, @Param("itemId") Long itemId);

    void batchMgsCategory(@Param("adds") List<KuaishouItemCategory> adds);

    void batchRocketCategory(@Param("adds") List<KuaishouItemCategory> adds);

    void batchYufuCategory(@Param("adds") List<KuaishouItemCategory> adds);

    void batchYuxiuCategory(@Param("adds") List<KuaishouItemCategory> adds);

    void batchZhishuiCategory(@Param("adds") List<KuaishouItemCategory> adds);
}

