package com.ruixuan.jiaoyang.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.ruixuan.common.utils.Check;
import com.ruixuan.common.utils.http.HttpUtils;
import com.ruixuan.jiaoyang.entity.JyAuthOrder;
import com.ruixuan.jiaoyang.mapper.JiaoYangReportMapper;
import com.ruixuan.jiaoyang.service.IJiaoYangReportService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
@Slf4j
public class JiaoYangReportServiceImpl implements IJiaoYangReportService {
    @Autowired
    private JiaoYangReportMapper jiaoYangReportMapper;

    @Override
    public List<JSONObject> item(Map<String, Object> requestMap) {
        return jiaoYangReportMapper.item(requestMap);
    }

    @Override
    public List<JSONObject> itemDetail(Map<String, Object> requestMap) {
        return jiaoYangReportMapper.itemDetail(requestMap);
    }

    @Override
    public List<JSONObject> promoter(Map<String, Object> requestMap) {
        return jiaoYangReportMapper.promoter(requestMap);
    }

    @Override
    public List<JSONObject> anchorOrderDetail(Map<String, Object> requestMap) {
        return jiaoYangReportMapper.anchorOrderDetail(requestMap);
    }

    @Override
    public List<JSONObject> promoterStatistics(Map<String, Object> requestMap) {
        return jiaoYangReportMapper.promoterStatistics(requestMap);
    }

    @Override
    public List<JSONObject> getClipCooperation(Long date, Long promoterId, String promoterName) {
        return jiaoYangReportMapper.getClipCooperation(date, promoterId, promoterName);
    }

    @Override
    public JSONObject getOrderTotal(Map<String, Object> requestMap) {
        return jiaoYangReportMapper.getOrderTotal(requestMap);
    }

    @Override
    public Double getOrderTotalRatio(Map<String, Object> ratioMap) {
        return jiaoYangReportMapper.getOrderTotalRatio(ratioMap);
    }

    @Override
    public JSONObject getServiceAmountTotal(Map<String, Object> requestMap) {
        return jiaoYangReportMapper.getServiceAmountTotal(requestMap);
    }

    @Override
    public JSONObject getAmountTotal(Map<String, Object> requestMap) {
        return jiaoYangReportMapper.getAmountTotal(requestMap);
    }

    @Override
    public Double getAmountTotalRatio(Map<String, Object> ratioMap) {
        return jiaoYangReportMapper.getAmountTotalRatio(ratioMap);
    }

    @Override
    public List<JSONObject> getPromoterRankRatioList(Map<String, Object> requestMap) {
        return jiaoYangReportMapper.getPromoterRankRatioList(requestMap);
    }

    @Override
    public List<JSONObject> getPromoterRatioList(Map<String, Object> requestMap) {
        return jiaoYangReportMapper.getPromoterRatioList(requestMap);
    }

    @Override
    public List<JSONObject> getOrderRankRatioList(Map<String, Object> requestMap) {
        return jiaoYangReportMapper.getOrderRankRatioList(requestMap);
    }

    @Override
    public List<JSONObject> getOrderRankList(Map<String, Object> requestMap) {
        return jiaoYangReportMapper.getOrderRankList(requestMap);
    }

    @Override
    public List<JSONObject> indexStatistics(Map<String, Object> requestMap) {
        return jiaoYangReportMapper.indexStatistics(requestMap);
    }

    @Override
    public JSONObject getTimeIntervalRatio(Map<String, Object> requestMap) {
        return jiaoYangReportMapper.getTimeIntervalRatio(requestMap);
    }

    @Override
    public List<Long> getPromoterIdsByUserIds(List<Long> userIds) {
        return jiaoYangReportMapper.getPromoterIdsByUserIds(userIds);
    }

    @Override
    public JSONObject dayData(Long startDate, Long endDate, Long lastStart, Long lastEnd, Integer dataType) {
        return jiaoYangReportMapper.dayData(startDate, endDate, lastStart, lastEnd, dataType);
    }

    @Override
    public JSONObject monthData(Long nowMonthStartDate, Long nowMonthEndDate, Long lastMonthStartDate, Long lastMonthEndDate, Integer dataType) {
        return jiaoYangReportMapper.monthData(nowMonthStartDate, nowMonthEndDate, lastMonthStartDate, lastMonthEndDate, dataType);
    }

    @Override
    public List<JSONObject> getTopItem(Long date, Long promoterId, String fieId, String sort) {
        return jiaoYangReportMapper.getTopItem(date, promoterId, fieId, sort);
    }

    @Override
    public List<JSONObject> getTopItemUser() {
        return jiaoYangReportMapper.getTopItemUser();
    }

    @Override
    public List<JSONObject> getDataByDate(Long strDateTimsToInt) {
        return jiaoYangReportMapper.getDataByDate(strDateTimsToInt);
    }

    @Override
    public String getJiaoYangCookie() {
        return jiaoYangReportMapper.getJiaoYangCookie();
    }

    @Override
    public void getAuthItem(String cookie, Integer offset, Integer count) throws InterruptedException {
        Thread.sleep(1000L);
        Map<String, Object> params = new HashMap<>();
        params.put("limit", 10);
        params.put("offset", offset);
        params.put("status", 1);
        Map<String, String> headers = new HashMap<>();
        headers.put("Cookie", cookie);
        String postUrl = "https://cps.kwaixiaodian.com/gateway/distribute/app/section/mcn/query/empower/item/list";
        String resultStr = HttpUtils.httpPostRequest(postUrl, params, headers);
        JSONObject result = JSONObject.parseObject(resultStr);
        if (Check.isNull(result)) {
            log.error("骄阳授权商品数据返回为空");
            return;
        }
        Integer code = result.getInteger("result");
        if (code != 1) {
            log.info("骄阳授权商品数据返回异常：", resultStr);
            return;
        }
        JSONObject dataJson = result.getJSONObject("data");
        if (Check.isNull(dataJson)) {
            log.error("骄阳授权商品返回为data数据为空");
            return;
        }
        JSONArray list = dataJson.getJSONArray("mcnEmpowerItem");
        if (Check.isNull(list)) {
            log.error("骄阳授权商品返回为list数据为空");
            return;
        }
        log.info("骄阳授权商品当前数据条数:{}", list.size());
        List<JyAuthOrder> adds = new ArrayList<>();
        for (int i = 0; i < list.size(); i++) {
            JSONObject jsonObject = list.getJSONObject(i);
            JyAuthOrder order = new JyAuthOrder();
            order.setItemId(jsonObject.getLong("itemId"));
            order.setItemName(jsonObject.getString("itemName"));
            order.setItemImageUrl(jsonObject.getString("itemImageUrl"));
            order.setItemPriceView(jsonObject.getString("itemPriceView"));
            order.setCommissionRateView(jsonObject.getString("commissionRateView"));
            order.setPromoterId(jsonObject.getString("promoterId"));
            order.setPromoterNick(jsonObject.getString("promoterNick"));
            order.setPromoterPhoto(jsonObject.getString("promoterPhoto"));
            order.setMcnCommissionRateView(jsonObject.getString("mcnCommissionRateView"));
            order.setSortCount(count += 1);
            adds.add(order);
        }

        jiaoYangReportMapper.replaceItems(adds);
        if (list.size() >= 10) {
            getAuthItem(cookie, offset + 10, count);
        }
    }

    @Override
    public List<JSONObject> getAuthItemList(Map<String, Object> requestMap) {
        return jiaoYangReportMapper.getAuthItemList(requestMap);
    }

    @Override
    public void deleteAuthItem() {
        jiaoYangReportMapper.deleteAuthItem();
    }

    @Override
    public JSONObject getTypeData(Long start, Long end) {
        return jiaoYangReportMapper.getTypeData(start, end);
    }

    @Override
    public List<Long> getPromoterIdsByBusinessId(Long userId) {
        return jiaoYangReportMapper.getPromoterIdsByBusinessId(userId);
    }

    @Override
    public List<Long> getPromoterIdsByMentorId(Long userId) {
        return jiaoYangReportMapper.getPromoterIdsByMentorId(userId);
    }
}
