package com.ruixuan.jinniu.service;


import com.alibaba.fastjson.JSONObject;
import com.ruixuan.jinniu.entity.KuaishouTransferAccount;

import java.util.List;

/**
 * 账户转让记录Service接口
 *
 * @author ruoyi
 * @date 2023-03-16
 */
public interface IKuaishouTransferAccountService {
    /**
     * 查询账户转让记录
     *
     * @param id 账户转让记录主键
     * @return 账户转让记录
     */
    public KuaishouTransferAccount selectKuaishouTransferAccountById(Long id);

    /**
     * 查询账户转让记录列表
     *
     * @param kuaishouTransferAccount 账户转让记录
     * @return 账户转让记录集合
     */
    public List<JSONObject> selectKuaishouTransferAccountList(KuaishouTransferAccount account);

    /**
     * 新增账户转让记录
     *
     * @param kuaishouTransferAccount 账户转让记录
     * @return 结果
     */
    public int insertKuaishouTransferAccount(KuaishouTransferAccount kuaishouTransferAccount);

    /**
     * 修改账户转让记录
     *
     * @param kuaishouTransferAccount 账户转让记录
     * @return 结果
     */
    public int updateKuaishouTransferAccount(KuaishouTransferAccount kuaishouTransferAccount);

    /**
     * 删除账户转让记录信息
     *
     * @param id 账户转让记录主键
     * @return 结果
     */
    public int deleteKuaishouTransferAccountById(Long id);
}