package com.ruixuan.live.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 快手—直播-附属文件（数据大盘、画像、复盘数据） kuaishou_live_broadcast_files
 */
@Data
@ApiModel(value = "kuaishouLiveBroadcastFiles", description = "快手—直播-附属文件（数据大盘、画像、复盘数据）")
public class KuaishouLiveBroadcastFiles implements Serializable {
    private static final long serialVersionUID = 1L;

    /**
     * 与直播表（kuaishou_live_broadcast）id一致
     */
    private String id;

    /**
     * 上传操作通用前缀链接
     */
    @ApiModelProperty(name = "上传操作通用前缀链接")
    private String upCommonUrl;

    /**
     * 上传数据大盘图片数量
     */
    @ApiModelProperty(name = "上传数据大盘图片数量")
    private Integer dapanCount;

    /**
     * 数据大盘名称集
     */
    @ApiModelProperty(name = "数据大盘名称集")
    private String dapanNames;

    /**
     * 上传COS结果说明
     */
    @ApiModelProperty(name = "上传COS结果说明")
    private String dapanMsg;

    /**
     * 上传画像分析图片数量
     */
    @ApiModelProperty(name = "上传画像分析图片数量")
    private Integer portraitCount;

    /**
     * 画像分析名称集
     */
    @ApiModelProperty(name = "画像分析名称集")
    private String portraitNames;

    /**
     * 上传COS结果说明
     */
    @ApiModelProperty(name = "上传COS结果说明")
    private String portraitMsg;

    /**
     * 复盘操作通用前缀链接
     */
    @ApiModelProperty(name = "复盘操作通用前缀链接")
    private String replayCommonUrl;

    /**
     * 上传复盘图片数量
     */
    @ApiModelProperty(name = "上传复盘图片数量")
    private Integer replayPictureCount;

    /**
     * 复盘图片名称集
     */
    @ApiModelProperty(name = "复盘图片名称集")
    private String replayPictureNames;

    /**
     * 上传COS结果说明
     */
    @ApiModelProperty(name = "上传COS结果说明")
    private String replayPictureMsg;

    /**
     * 复盘文件链接
     */
    @ApiModelProperty(name = "复盘文件链接")
    private String replayFileUrl;

    /**
     * 更新时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;

    /**
     * 创建时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;

}
