package com.ruixuan.live.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * 快手直播项目对象 kuaishou_live_project
 */
@Data
@ApiModel(value = "kuaishouLiveProject", description = "快手直播项目")
public class KuaishouLiveProject {
    private static final long serialVersionUID = 1L;

    /**
     * 账户ID
     */
    private Long id;

    /**
     * 项目名称
     */
    @ApiModelProperty(name = "项目名称")
    private String projectName;

    /**
     * 项目状态：1-生效，0-无效
     */
    @ApiModelProperty(name = "项目状态：1-生效，0-无效")
    private String state;

    /**
     * 更新时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;

    /**
     * 创建时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;
}
