package com.ruixuan.live.service;

import com.ruixuan.common.core.domain.ResultResponse;
import com.ruixuan.live.entity.KuaishouLiveBroadcast;
import com.ruixuan.live.entity.KuaishouLiveCustomer;
import com.ruixuan.live.entity.KuaishouLiveCustomerInvoice;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * 客户管理Service接口
 *
 * @author ruoyi
 * @date 2022-08-01
 */
public interface IKuaishouLiveCustomerService
{
    /**
     * 查询客户管理
     *
     * @param ksId 客户管理主键
     * @return 客户管理
     */
    public KuaishouLiveCustomer selectKuaishouLiveCustomerByKsId(Long ksId);

    /**
     * 查询客户管理列表
     *
     * @param kuaishouLiveCustomer 客户管理
     * @return 客户管理集合
     */
    public List<KuaishouLiveCustomer> selectKuaishouLiveCustomerList(KuaishouLiveCustomer kuaishouLiveCustomer);

    /**
     * 新增客户管理
     *
     * @param kuaishouLiveCustomer 客户管理
     * @return 结果
     */
    public ResultResponse insertKuaishouLiveCustomer(KuaishouLiveCustomer kuaishouLiveCustomer);

    /**
     * 修改客户管理
     *
     * @param kuaishouLiveCustomer 客户管理
     * @return 结果
     */
    public ResultResponse updateKuaishouLiveCustomer(KuaishouLiveCustomer kuaishouLiveCustomer);

    ResultResponse addInvoice(KuaishouLiveCustomerInvoice invoice);
}