package com.ruixuan.live.service.impl;

import com.ruixuan.common.utils.DateUtils;
import com.ruixuan.live.entity.KuaishouLiveUserAccountPart;
import com.ruixuan.live.mapper.KuaishouLiveUserAccountPartMapper;
import com.ruixuan.live.service.IKuaishouLiveUserAccountPartService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 快手账户协作人群Service业务层处理
 *
 * @author ruoyi
 * @date 2022-05-31
 */
@Service
public class KuaishouLiveUserAccountPartServiceImpl implements IKuaishouLiveUserAccountPartService {
    @Autowired
    private KuaishouLiveUserAccountPartMapper kuaishouLiveUserAccountPartMapper;

    /**
     * 查询快手账户协作人群
     *
     * @param id 快手账户协作人群主键
     * @return 快手账户协作人群
     */
    @Override
    public List<KuaishouLiveUserAccountPart> selectKuaishouLiveUserAccountPartById(Long ksId) {
        return kuaishouLiveUserAccountPartMapper.selectKuaishouLiveUserAccountPartById(ksId);
    }


    /**
     * 删除快手账户协作人群信息
     *
     * @param id 快手账户协作人群主键
     * @return 结果
     */
    @Override
    public int deleteKuaishouLiveUserAccountPartById(Long ksId) {
        return kuaishouLiveUserAccountPartMapper.deleteKuaishouLiveUserAccountPartById(ksId);
    }
}
